/*detect a motion and send an RF signal*/
/*use sleep mode*/

#include <avr/sleep.h>
#include <avr/power.h>
#include <RH_ASK.h>
#include <SPI.h> //needed for RH_ASH.h

#define PIR 2
#define NODE_ID 1
#define OUTPUT_PIN 9
#define RELAY_PIN 10
#define ADC A0
#define VERBOSE true
  
const char *msg = "PIR_4"; 

//RH_ASK driver;
RH_ASK driver(2000,5,9);

void setup() 
{
  pinMode(OUTPUT_PIN,OUTPUT);
  pinMode(PIR, INPUT);
  pinMode(RELAY_PIN, OUTPUT); 
  pinMode(13,OUTPUT);
  pinMode(A0,INPUT);
  digitalWrite(13,LOW);
  digitalWrite(RELAY_PIN, LOW);
  attachInterrupt(0,wakeUp,RISING); //attaching an interrupt to pin D2
  if (!driver.init()) Serial.println("init failed");
  if (VERBOSE) Serial.begin(9600);
  if (VERBOSE)Serial.println("started");
  Welcome(); //blink built-in led to welcome
}

void loop() 
{  
  if (VERBOSE) Serial.println("going to sleep mode");
  Going_To_Sleep();
  if (VERBOSE) delay(250); //let time to send the serial message before going to sleep

  // ... woke up
  if (VERBOSE) Serial.println("woke up!");

  //check the battery supply voltage
  if (VERBOSE)
  {
    Serial.print("battery voltage (must be >480 units): ");
    Serial.println(analogRead(A0));
  }
  if (true) //(analogRead(A0)>480) //>2.25 V
  {
    digitalWrite(13,HIGH);
    
    digitalWrite(RELAY_PIN, HIGH);
    delay(500);  //let time to the RF module to wake-up
  
   for (int i=0;i<1;i++) //send two times
    {
    driver.send((uint8_t *)msg, strlen(msg));
    driver.waitPacketSent();
    delay(125);
    }
  
    digitalWrite(RELAY_PIN, LOW);
    //while (digitalRead(PIR)==HIGH){} //wait for the PIR to release
    digitalWrite(13,LOW);
    if (VERBOSE)  { Serial.println("rf msg sent"); delay(250);}
  }
  else 
  {
    if (VERBOSE) {Serial.println("no rf msg sent"); delay(250);} 
    Welcome();
  }
}

void Going_To_Sleep()
{
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
  sleep_enable();
  interrupts();
  sleep_cpu();  
}

void wakeUp()
{
  //cli(); -> not sure for RF Tx library
  //Serial.println("Interrupt Fired");
}

void Welcome()
{
  for (uint8_t i=0;i<5;i++)
  {
    digitalWrite(13,HIGH);
    delay(500);
    digitalWrite(13,LOW);
    delay(500);
  }
}
